// Generated by CoffeeScript 1.9.3
var Feed,
  bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

module.exports = Feed = (function() {
  Feed.prototype.axonSock = void 0;

  function Feed() {
    this.publish = bind(this.publish, this);
    this.logger = require('printit')({
      date: true,
      prefix: 'helper/db_feed'
    });
  }

  Feed.prototype.initialize = function(server) {
    this.startPublishingToAxon();
    return server.on('close', (function(_this) {
      return function() {
        if (_this.axonSock != null) {
          return _this.axonSock.close();
        }
      };
    })(this));
  };

  Feed.prototype.startPublishingToAxon = function() {
    var axon, axonPort;
    axon = require('axon');
    this.axonSock = axon.socket('pub');
    axonPort = parseInt(process.env.AXON_PORT || 9105);
    this.axonSock.connect(axonPort);
    return this.logger.info('Pub server started');
  };

  Feed.prototype.publish = function(event, id) {
    this.logger.info("Publishing " + event + " " + id);
    if (this.axonSock != null) {
      return this.axonSock.send(event, id);
    }
  };

  return Feed;

})();

module.exports = new Feed();
