// Generated by CoffeeScript 1.9.3
var CozyInstance, americano, log, path;

americano = require('cozy-db-pouchdb');

path = require('path');

log = require('printit')({
  prefix: 'Files'
});

module.exports = CozyInstance = {};

CozyInstance.first = function(callback) {
  var configPath, instance;
  configPath = path.join(process.cwd(), 'config');
  try {
    instance = require(configPath);
  } catch (_error) {
    console.log(err);
    log.error('No config file found at ' + configPath);
    instance = {};
  }
  if (instance.domain == null) {
    instance.domain = 'default.domain.com';
  }
  if (instance.locale == null) {
    instance.locale = 'en';
  }
  return callback(null, instance);
};

CozyInstance.getURL = function(callback) {
  return CozyInstance.first(function(err, instance) {
    return callback(null, instance.domain);
  });
};

CozyInstance.getLocale = function(callback) {
  return CozyInstance.first(function(err, instance) {
    return callback(null, instance.locale);
  });
};
